-- <ScriptOptions statementTerminator="^" />
--#SET DELIMITER ^

DROP INDEX RAMSCHEMA.FA_FORUM_ASSET_IDX^
DROP INDEX RAMSCHEMA.UGU_US_UG_NDX^

-- Got tired of maintaining triggers in the UML because always needed something slightly different for each system. So instead
-- just putting them in each override file instead.
DROP TRIGGER RAMSCHEMA.LIC_COUNTS_ADD^
DROP TRIGGER RAMSCHEMA.LIC_COUNTS_REMOVE^

DROP TRIGGER RAMSCHEMA.ASSET_UPDATED_REC^

DROP TRIGGER RAMSCHEMA.ASSET_UPDATED_ART^

DROP TRIGGER RAMSCHEMA.AT_DELETE^

DROP TRIGGER RAMSCHEMA.CL_UPDATED^

DROP TRIGGER RAMSCHEMA.FREQ_CHANGED^

DROP TRIGGER RAMSCHEMA.FREQ_DFLT_CHANGED^

DROP TRIGGER RAMSCHEMA.INSRT_SUBSCRIPTION^

DROP TRIGGER RAMSCHEMA.FORUM_UPDATE^

DROP TRIGGER RAMSCHEMA.TOPIC_DEL_ATTACH^

DROP TRIGGER RAMSCHEMA.TOPIC_UPDATE_REC^

DROP TRIGGER RAMSCHEMA.TOPIC_INSERT_FORUM^

DROP TRIGGER RAMSCHEMA.TOPIC_UPDATE_FORUM^

DROP TRIGGER RAMSCHEMA.TOPIC_DELETE_FORUM^

DROP TRIGGER RAMSCHEMA.POST_DELETE_ATTACH^

DROP TRIGGER RAMSCHEMA.POST_UPDATE_REC^

DROP TRIGGER RAMSCHEMA.POST_INSERT_TOPIC^

DROP TRIGGER RAMSCHEMA.POST_UPDATE_TOPIC^

DROP TRIGGER RAMSCHEMA.POST_DELETE_TOPIC^

DROP TRIGGER RAMSCHEMA.ATCM_DELETED^

ALTER TABLE RAMSCHEMA.ASSET DROP CONSTRAINT SQL060302161907351^

ALTER TABLE RAMSCHEMA.ASSET DROP CONSTRAINT SQL060302161907681^

ALTER TABLE RAMSCHEMA.ASSET DROP CONSTRAINT C7034435^

ALTER TABLE RAMSCHEMA.ASSET DROP CONSTRAINT ASSET_LIFECYCLE_FK^

ALTER TABLE RAMSCHEMA.GROUPUSERROLE DROP CONSTRAINT SQL060302161908452^

ALTER TABLE RAMSCHEMA.GROUPUSERROLE DROP CONSTRAINT SQL060302161908450^

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC DROP CONSTRAINT SQL060302161908680^

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC DROP CONSTRAINT C7264217^

ALTER TABLE RAMSCHEMA.REPOSITORYROLE DROP CONSTRAINT C8818139^

ALTER TABLE RAMSCHEMA.REPOSROLEENTITLEMENT DROP CONSTRAINT SQL060302161908790^

ALTER TABLE RAMSCHEMA.RESOURCEGROUP DROP CONSTRAINT COMMUNITY_ASSET_FK^

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP DROP CONSTRAINT C6359167^

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP DROP CONSTRAINT C5886019^

ALTER TABLE RAMSCHEMA.REVIEW_PROCESS DROP CONSTRAINT C9952475^

ALTER TABLE RAMSCHEMA.SUBSCRIPTION DROP CONSTRAINT C8704685^

ALTER TABLE RAMSCHEMA.TAG DROP CONSTRAINT C5102136^

ALTER TABLE RAMSCHEMA.TAG DROP CONSTRAINT C7483428^

ALTER TABLE RAMSCHEMA.ASSETVERSIONHISTORY DROP CONSTRAINT C1003852^

ALTER TABLE RAMSCHEMA.TODO DROP CONSTRAINT C8990529^

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER DROP CONSTRAINT C5745917^

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER DROP CONSTRAINT C4245457^

ALTER TABLE RAMSCHEMA.PTREPO DROP CONSTRAINT C0062924^

ALTER TABLE RAMSCHEMA.PTREPO DROP CONSTRAINT C3934317^

ALTER TABLE RAMSCHEMA.PTCONFIG DROP CONSTRAINT C7658548^

ALTER TABLE RAMSCHEMA.PTCONFIG_USER DROP CONSTRAINT C5288775^

ALTER TABLE RAMSCHEMA.PTCONFIG_USER DROP CONSTRAINT C8866283^

ALTER TABLE RAMSCHEMA.PTQUERY DROP CONSTRAINT C6065876^

ALTER TABLE RAMSCHEMA.USER_PREFERENCES DROP CONSTRAINT C4134514134^

ALTER TABLE RAMSCHEMA.USERGROUP DROP CONSTRAINT UGR_RESGROUP_FK^

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE DROP CONSTRAINT UGR_UGR_FK^

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE DROP CONSTRAINT UGR_ROLE_FK^

ALTER TABLE RAMSCHEMA.USERGROUP_USER DROP CONSTRAINT UGU_USER_FK^

ALTER TABLE RAMSCHEMA.USERGROUP_USER DROP CONSTRAINT UGU_UGR_FK^

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP DROP CONSTRAINT UGR_ASSET_FK^

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP DROP CONSTRAINT UGR_USERGROUP_FK^

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR DROP CONSTRAINT PTCUG_PTCONFIG_FK^

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR DROP CONSTRAINT PTCUG_USERGROUP_FK^

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP DROP CONSTRAINT TO_UGRP_TODO_FK^

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP DROP CONSTRAINT TO_UGRP_UGRP_FK^

ALTER TABLE RAMSCHEMA.FORUM DROP CONSTRAINT FORUM_PTCONFIG_FK^

ALTER TABLE RAMSCHEMA.FORUM DROP CONSTRAINT FORUM_OWNER_FK^

ALTER TABLE RAMSCHEMA.TOPIC DROP CONSTRAINT TOPIC_FORUM_FK^

ALTER TABLE RAMSCHEMA.TOPIC DROP CONSTRAINT TOPIC_USERID_FK^

ALTER TABLE RAMSCHEMA.TOPIC DROP CONSTRAINT TOPIC_ATTACH_FK^

ALTER TABLE RAMSCHEMA.POST DROP CONSTRAINT POST_TOPIC_FK^

ALTER TABLE RAMSCHEMA.POST DROP CONSTRAINT POST_REPLY_FK^

ALTER TABLE RAMSCHEMA.POST DROP CONSTRAINT POST_ATTACHMENT_FK^

ALTER TABLE RAMSCHEMA.POST DROP CONSTRAINT POST_AUTHOR_FK^

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM DROP CONSTRAINT PTQF_QUERY_FK^

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM DROP CONSTRAINT PTQF_FORUM_FK^

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN DROP CONSTRAINT ATCM_ASSETTYPE_FK^

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN DROP CONSTRAINT ATCM_COMMUN_FK^

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM DROP CONSTRAINT CC_SCHEMA_FK^

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM DROP CONSTRAINT CC_COMMUNITY_FK^

ALTER TABLE RAMSCHEMA.EXTENSION_POINT DROP CONSTRAINT EXT_ASSET_FK^

ALTER TABLE RAMSCHEMA.FORUM_ASSET DROP CONSTRAINT FORUM_ASSET_FK^

ALTER TABLE RAMSCHEMA.FORUM_ASSET DROP CONSTRAINT FORUM_AST_FRM_FK^

ALTER TABLE RAMSCHEMA.LIBRARY DROP CONSTRAINT L_LIBASSET_FK^

ALTER TABLE RAMSCHEMA.FAVORITE DROP CONSTRAINT FV_USER_FK^

ALTER TABLE RAMSCHEMA.LICENSE DROP CONSTRAINT LICENSE_USERID_FK^

ALTER TABLE RAMSCHEMA.LIFECYCLE DROP CONSTRAINT LIFECYCLE_ASSET_FK^

ALTER TABLE RAMSCHEMA.LIFECYCLE DROP CONSTRAINT LC_COMMUNITY_FK^

ALTER TABLE RAMSCHEMA.ASSET DROP CONSTRAINT SQL060302161907350^

ALTER TABLE RAMSCHEMA.ASSETTYPE DROP CONSTRAINT SQL060302161906150^

ALTER TABLE RAMSCHEMA.CLASSIFSCHEMA DROP CONSTRAINT SQL060302161906350^

ALTER TABLE RAMSCHEMA.GROUPUSERROLE DROP CONSTRAINT C0012647^

ALTER TABLE RAMSCHEMA.ASSETRELATIONTYPE DROP CONSTRAINT C9171363^

ALTER TABLE RAMSCHEMA.ASSETRELATIONTYPE DROP CONSTRAINT RELTYPE_DN^

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC DROP CONSTRAINT C4752929^

ALTER TABLE RAMSCHEMA.REPOSITORYROLE DROP CONSTRAINT SQL060302161905930^

ALTER TABLE RAMSCHEMA.REPOSROLEENTITLEMENT DROP CONSTRAINT C4170611^

ALTER TABLE RAMSCHEMA.RESOURCEGROUP DROP CONSTRAINT SQL060302161904960^

ALTER TABLE RAMSCHEMA.STATE DROP CONSTRAINT SQL060302161905260^

ALTER TABLE RAMSCHEMA.USERID DROP CONSTRAINT SQL060302161905480^

ALTER TABLE RAMSCHEMA.AUTOKEYGEN DROP CONSTRAINT C9766869^

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP DROP CONSTRAINT C3386788^

ALTER TABLE RAMSCHEMA.CONFIGURATION DROP CONSTRAINT C9628234^

ALTER TABLE RAMSCHEMA.REVIEW_PROCESS DROP CONSTRAINT C3977115^

ALTER TABLE RAMSCHEMA.SUBSCRIPTION DROP CONSTRAINT C9854034^

ALTER TABLE RAMSCHEMA.TAG DROP CONSTRAINT C3930063^

ALTER TABLE RAMSCHEMA.ASSETVERSIONHISTORY DROP CONSTRAINT C7220450^

ALTER TABLE RAMSCHEMA.TODO DROP CONSTRAINT C6295873^

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER DROP CONSTRAINT C8444015^

ALTER TABLE RAMSCHEMA.PTREPO DROP CONSTRAINT C0201947^

ALTER TABLE RAMSCHEMA.PTCONFIG DROP CONSTRAINT C3648890^

ALTER TABLE RAMSCHEMA.PTCONFIG_USER DROP CONSTRAINT C6415283^

ALTER TABLE RAMSCHEMA.PTQUERY DROP CONSTRAINT C0491965^

ALTER TABLE RAMSCHEMA.STALECACHE DROP CONSTRAINT C3686525^

ALTER TABLE RAMSCHEMA.USER_PREFERENCES DROP CONSTRAINT C12341234^

ALTER TABLE RAMSCHEMA.USERGROUP DROP CONSTRAINT USERGROUP_PK^

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE DROP CONSTRAINT USERGROUPROLE_PK^

ALTER TABLE RAMSCHEMA.USERGROUP_USER DROP CONSTRAINT USERGROUP_USER_PK^

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP DROP CONSTRAINT UGR_PK^

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR DROP CONSTRAINT PTCONFIG_UGR_PK^

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP DROP CONSTRAINT TODO_TRGT_UGRP_PK^

ALTER TABLE RAMSCHEMA.FORUM DROP CONSTRAINT FORUM_PK^

ALTER TABLE RAMSCHEMA.TOPIC DROP CONSTRAINT TOPIC_PK^

ALTER TABLE RAMSCHEMA.ATTACHMENT DROP CONSTRAINT ATTACHMENT_PK^

ALTER TABLE RAMSCHEMA.POST DROP CONSTRAINT POST_PK^

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM DROP CONSTRAINT PT_QUERY_FORUM_PK^

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN DROP CONSTRAINT ASSETTYP_COMMUN_PK^

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM DROP CONSTRAINT CLASSIFSCH_COMM_PK^

ALTER TABLE RAMSCHEMA.EXTENSION_POINT DROP CONSTRAINT EXTENSIONPOINT_PK^

ALTER TABLE RAMSCHEMA.FORUM_ASSET DROP CONSTRAINT FORUM_ASSET_PK^

ALTER TABLE RAMSCHEMA.LIBRARY DROP CONSTRAINT LIBRARY_CK^

ALTER TABLE RAMSCHEMA.FAVORITE DROP CONSTRAINT FAVORITES_PK^

ALTER TABLE RAMSCHEMA.BUSY_ASSET DROP CONSTRAINT BUSY_ASSET_PK^

ALTER TABLE RAMSCHEMA.TAG_MQT DROP CONSTRAINT TAG_MQT_PK^

ALTER TABLE RAMSCHEMA.LICENSE DROP CONSTRAINT LICENSE_PK^

ALTER TABLE RAMSCHEMA.COUNTS DROP CONSTRAINT COUNTS_PK^

ALTER TABLE RAMSCHEMA.LIFECYCLE DROP CONSTRAINT LIFECYCLE_PK^

DROP INDEX RAMSCHEMA.ASSET_EXTID^

DROP INDEX RAMSCHEMA.ASSET_COMMUN_TYPE^

DROP INDEX RAMSCHEMA.ASSET_LAST_DIRTY^

DROP INDEX RAMSCHEMA.ASSETTYPE_URI_IDX^

DROP INDEX RAMSCHEMA.CLSCHEMA_LSTMOD^

DROP INDEX RAMSCHEMA.METRICS_ASSET^

DROP INDEX RAMSCHEMA.METRIC_BY_ASSET^

DROP INDEX RAMSCHEMA.ROLE_RESGROUPID^

DROP INDEX RAMSCHEMA.STATE_ID^

DROP INDEX RAMSCHEMA.USER_USERID^

DROP INDEX RAMSCHEMA.UREL_UID^

DROP INDEX RAMSCHEMA.REVIEW_ORDER^

DROP INDEX RAMSCHEMA.SUBSCRB_TYP_ID_FRQ^

DROP INDEX RAMSCHEMA.SUBSCRB_UID^

DROP INDEX RAMSCHEMA.TAGS_USER^

DROP INDEX RAMSCHEMA.TAGS_ASSET_TAG^

DROP INDEX RAMSCHEMA.TAGS^

DROP INDEX RAMSCHEMA.ASTVERHSTRY_ASTID^

DROP INDEX RAMSCHEMA.TODO_TARGET_USERS^

DROP INDEX RAMSCHEMA.PTREPO_BY_GRP^

DROP INDEX RAMSCHEMA.PTCNF_BY_REPO^

DROP INDEX RAMSCHEMA.PTQUERY_BY_CNF^

DROP INDEX RAMSCHEMA.UG_RESGROUPID^

DROP INDEX RAMSCHEMA.UGU_UG_US_NDX^

DROP INDEX RAMSCHEMA.UGRPREL_UGRP^

DROP INDEX RAMSCHEMA.TODO_TARGET_UGRPS^

DROP INDEX RAMSCHEMA.TOPIC_ATTACHMENT^

DROP INDEX RAMSCHEMA.TOPIC_FORUM^

DROP INDEX RAMSCHEMA.POST_ATTACHMENT^

DROP INDEX RAMSCHEMA.POST_TOPIC^

DROP INDEX RAMSCHEMA.POST_REPLY^

DROP INDEX RAMSCHEMA.PTQF_BY_FORUM^

DROP INDEX RAMSCHEMA.EXT_POINT_BY_TYPE^

DROP INDEX RAMSCHEMA.FA_ASSET_FORUM_IDX^

DROP INDEX RAMSCHEMA.LIB_NDX^

DROP INDEX RAMSCHEMA.LIB_MODEL_IDX^

DROP INDEX RAMSCHEMA.FV_USER_NDX^

DROP INDEX RAMSCHEMA.TAG_LSTCRTD_NDX^

DROP INDEX RAMSCHEMA.TAG_LAST_UNIQ_NDX^

DROP INDEX RAMSCHEMA.LIC_LICENSE_NDX^

DROP INDEX RAMSCHEMA.COMMUNITY_NDX^

DROP TABLE RAMSCHEMA.ASSET^

DROP TABLE RAMSCHEMA.ASSETTYPE^

DROP TABLE RAMSCHEMA.CLASSIFSCHEMA^

DROP TABLE RAMSCHEMA.GROUPUSERROLE^

DROP TABLE RAMSCHEMA.ASSETRELATIONTYPE^

DROP TABLE RAMSCHEMA.REPOSITORYMETRIC^

DROP TABLE RAMSCHEMA.REPOSITORYROLE^

DROP TABLE RAMSCHEMA.REPOSROLEENTITLEMENT^

DROP TABLE RAMSCHEMA.RESOURCEGROUP^

DROP TABLE RAMSCHEMA.STATE^

DROP TABLE RAMSCHEMA.USERID^

DROP TABLE RAMSCHEMA.AUTOKEYGEN^

DROP TABLE RAMSCHEMA.USERRELATIONSHIP^

DROP TABLE RAMSCHEMA.CONFIGURATION^

DROP TABLE RAMSCHEMA.REVIEW_PROCESS^

DROP TABLE RAMSCHEMA.SUBSCRIPTION^

DROP TABLE RAMSCHEMA.TAG^

DROP TABLE RAMSCHEMA.ASSETVERSIONHISTORY^

DROP TABLE RAMSCHEMA.TODO^

DROP TABLE RAMSCHEMA.TODO_TARGET_USER^

DROP TABLE RAMSCHEMA.PTREPO^

DROP TABLE RAMSCHEMA.PTCONFIG^

DROP TABLE RAMSCHEMA.PTCONFIG_USER^

DROP TABLE RAMSCHEMA.PTQUERY^

DROP TABLE RAMSCHEMA.STALECACHE^

DROP TABLE RAMSCHEMA.USER_PREFERENCES^

DROP TABLE RAMSCHEMA.USERGROUP^

DROP TABLE RAMSCHEMA.USERGROUP_ROLE^

DROP TABLE RAMSCHEMA.USERGROUP_USER^

DROP TABLE RAMSCHEMA.UGRP_RELATIONSHIP^

DROP TABLE RAMSCHEMA.PTCONFIG_UGR^

DROP TABLE RAMSCHEMA.TODO_TARGET_UGRP^

DROP TABLE RAMSCHEMA.FORUM^

DROP TABLE RAMSCHEMA.TOPIC^

DROP TABLE RAMSCHEMA.ATTACHMENT^

DROP TABLE RAMSCHEMA.POST^

DROP TABLE RAMSCHEMA.PTQUERY_FORUM^

DROP TABLE RAMSCHEMA.ASSETTYPE_COMMUN^

DROP TABLE RAMSCHEMA.CLASSIFSCH_COMM^

DROP TABLE RAMSCHEMA.EXTENSION_POINT^

DROP TABLE RAMSCHEMA.FORUM_ASSET^

DROP TABLE RAMSCHEMA.LIBRARY^

DROP TABLE RAMSCHEMA.FAVORITE^

DROP TABLE RAMSCHEMA.BUSY_ASSET^

DROP TABLE RAMSCHEMA.TAG_MQT^

DROP TABLE RAMSCHEMA.LICENSE^

DROP TABLE RAMSCHEMA.COUNTS^

DROP TABLE RAMSCHEMA.LIFECYCLE^

DROP SCHEMA RAMSCHEMA RESTRICT^

CREATE SCHEMA RAMSCHEMA^

CREATE TABLE RAMSCHEMA.ASSET (
		ID INTEGER NOT NULL,
		ASSETTYPEID INTEGER,
		STATEID INTEGER,
		NAME VARCHAR(500),
		VERSION VARCHAR(80) NOT NULL,
		LAST_MODIFIED TIMESTAMP NOT NULL,
		MANIFEST CLOB(1 G) DEFAULT '<?xml version="1.0" encoding="UTF-8"?><xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI"/>' NOT NULL,
		EXTERNALID VARCHAR(80) NOT NULL,
		STORAGE_URI VARCHAR(1000),
		RESOURCEGROUP INTEGER NOT NULL,
		LAST_DIRTY TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL,
		ARTIFACT_DETAILS CLOB(1 G),
		LAST_ARTIFACTS_DIRTY TIMESTAMP,
		MANAGEMENT_STYLE INTEGER DEFAULT 0 NOT NULL,
		REVISION_COUNT INTEGER DEFAULT 0 NOT NULL,
		ROW_VERSION INTEGER DEFAULT 65537 NOT NULL,
		PERSIST_COUNT INTEGER DEFAULT 0 NOT NULL,
		PENDING_CTRL_FLAG SMALLINT DEFAULT 0 NOT NULL,
		PENDING_STATUS SMALLINT NOT NULL,
		A_LCID VARCHAR(100)
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.ASSETTYPE (
		ID INTEGER NOT NULL,
		NAME VARCHAR(125) NOT NULL,
		VERSION VARCHAR(80),
		URI VARCHAR(256) NOT NULL,
		DESCRIPTION VARCHAR(512),
		CONFIGURATION CLOB(1 G),
		RESTRICTED CHAR(1),
		AT_COLLISION INTEGER DEFAULT 0 NOT NULL,
		AT_ATTR_CONTAINER VARCHAR(1000) DEFAULT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.CLASSIFSCHEMA (
		URI VARCHAR(1000) NOT NULL,
		NAME VARCHAR(256),
		LAST_MODIFIED TIMESTAMP NOT NULL,
		CL_SCHEMA CLOB(1 G) DEFAULT '<?xml version="1.0" encoding="UTF-8"?><xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI"/>' NOT NULL,
		FRAGMENT VARCHAR(100) NOT NULL,
		CL_COLLISION INTEGER NOT NULL,
		CL_SHARED INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.GROUPUSERROLE (
		USERID INTEGER NOT NULL,
		REPOSITORYROLEID INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.ASSETRELATIONTYPE (
		NAME VARCHAR(128) NOT NULL,
		DISPLAY_NAME VARCHAR(128) NOT NULL,
		REVERSE_NAME VARCHAR(128)
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.REPOSITORYMETRIC (
		ASSETID INTEGER,
		TIME_STAMP TIMESTAMP NOT NULL,
		USERID INTEGER,
		METRICTYPE INTEGER NOT NULL,
		NUMBER_DATA BIGINT,
		STRING_DATA VARCHAR(1024),
		ID BIGINT NOT NULL,
		LARGE_STRING_DATA CLOB(1 G),
		COLLISION INTEGER DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.REPOSITORYROLE (
		ID INTEGER NOT NULL,
		NAME VARCHAR(80) NOT NULL,
		RESOURCEGROUPID INTEGER NOT NULL,
		TEST_DATA VARCHAR(3000),
		ROLE_TYPE INTEGER DEFAULT 0 NOT NULL,
		DESCRIPTION VARCHAR(512),
		RR_RELATE_KIND BIGINT DEFAULT 8 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.REPOSROLEENTITLEMENT (
		REPOSROLEID INTEGER NOT NULL,
		ENTITLEID INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.RESOURCEGROUP (
		ID INTEGER NOT NULL,
		NAME VARCHAR(80) NOT NULL,
		DESCRIPTION VARCHAR(1000),
		COMMUNITY_ASSETID INTEGER
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.STATE (
		ID INTEGER NOT NULL,
		NAME VARCHAR(80) NOT NULL,
		STATE_WF_ID VARCHAR(1000) NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.USERID (
		ID INTEGER NOT NULL,
		NAME VARCHAR(80) NOT NULL,
		EMAIL VARCHAR(80),
		PHONE VARCHAR(80),
		USERID VARCHAR(80) NOT NULL,
		EMAIL_FORMAT INTEGER DEFAULT 0 NOT NULL,
		SUBSCRIPTION_FREQUENCY INTEGER DEFAULT 0 NOT NULL,
		UID_STATUS SMALLINT DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.AUTOKEYGEN (
		IDENTIFIER INTEGER DEFAULT 1 NOT NULL,
		NEXT_USER INTEGER DEFAULT 1000 NOT NULL,
		NEXT_RESOURCEGROUP INTEGER DEFAULT 1000 NOT NULL,
		NEXT_REPOSITORYROLE INTEGER DEFAULT 1000 NOT NULL,
		NEXT_ASSET INTEGER DEFAULT 1000 NOT NULL,
		NEXT_ASSETTYPE INTEGER DEFAULT 1000 NOT NULL,
		NEXT_STATE INTEGER DEFAULT 1000 NOT NULL,
		NEXT_METRIC BIGINT DEFAULT 1000 NOT NULL,
		NEXT_REVIEW_PROCESS INTEGER DEFAULT 1000 NOT NULL,
		NEXT_TAG INTEGER DEFAULT 1000 NOT NULL,
		NEXT_PTREPO INTEGER DEFAULT 1000 NOT NULL,
		NEXT_PTCONFIG INTEGER DEFAULT 1000 NOT NULL,
		NEXT_PTQUERY INTEGER DEFAULT 1000 NOT NULL,
		NEXT_USERGROUP INTEGER DEFAULT 1000 NOT NULL,
		NEXT_FORUM INTEGER DEFAULT 1000 NOT NULL,
		NEXT_TOPIC INTEGER DEFAULT 1000 NOT NULL,
		NEXT_POST BIGINT DEFAULT 1000 NOT NULL,
		NEXT_ATTACHMENT BIGINT DEFAULT 1000 NOT NULL,
		NEXT_EXTENSION_POINT INTEGER DEFAULT 1000 NOT NULL,
		NEXT_SUBSCRIPTION INTEGER DEFAULT 1000 NOT NULL,
		NEXT_FAVORITE INTEGER DEFAULT 1000 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.USERRELATIONSHIP (
		ASSETID INTEGER NOT NULL,
		USERID INTEGER NOT NULL,
		KIND INTEGER DEFAULT 0 NOT NULL,
		UR_RESTRICT BIGINT DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.CONFIGURATION (
		CONFIG_KEY VARCHAR(256) NOT NULL,
		VALUE VARCHAR(3072)
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.REVIEW_PROCESS (
		GROUPID INTEGER NOT NULL,
		ORDER_IN_GROUP DOUBLE NOT NULL,
		REVIEW_INFO CLOB(1 G),
		ID INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.SUBSCRIPTION (
		USERID INTEGER NOT NULL,
		CREATED TIMESTAMP NOT NULL,
		SUBSCRIPTION_TYPE INTEGER NOT NULL,
		NAME VARCHAR(256) NOT NULL,
		LAST_RUN TIMESTAMP,
		PARAMETERS VARCHAR(1024),
		FREQUENCY INTEGER DEFAULT 0 NOT NULL,
		FREQ_DEFAULTED CHAR(1) DEFAULT NULL,
		DBID BIGINT,
		SUB_ID INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.TAG (
		ID INTEGER NOT NULL,
		ASSET_ID INTEGER NOT NULL,
		USER_ID INTEGER NOT NULL,
		LABEL VARCHAR(64) NOT NULL,
		TAG VARCHAR(64) NOT NULL,
		CREATED TIMESTAMP NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.ASSETVERSIONHISTORY (
		EXTERNALID VARCHAR(80) NOT NULL,
		VERSION VARCHAR(80) NOT NULL,
		ASSETID INTEGER NOT NULL,
		AVH_SUBMISSION CHAR(1) NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.TODO (
		REQUESTING_USER INTEGER NOT NULL,
		TYPE INTEGER NOT NULL,
		ACTION_LINK VARCHAR(1000) NOT NULL,
		DESCRIPTION VARCHAR(2000) NOT NULL,
		CREATED TIMESTAMP NOT NULL,
		COMPLETED TIMESTAMP,
		COMPLETED_COMMENT VARCHAR(4000)
	)
	 IN USERSPACE16K INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.TODO_TARGET_USER (
		TODO_TU_REQ_USER INTEGER NOT NULL,
		TODO_TU_TYPE INTEGER NOT NULL,
		TODO_TU_LINK VARCHAR(1000) NOT NULL,
		TU_USERID INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.PTREPO (
		PTR_ID INTEGER NOT NULL,
		PTR_NAME VARCHAR(256) NOT NULL,
		PTR_DESCRIPTION VARCHAR(2000),
		PTR_TYPE INTEGER NOT NULL,
		PTR_GROUPID INTEGER NOT NULL,
		PTR_OWNERID INTEGER,
		PTR_METADATA CLOB NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.PTCONFIG (
		PTC_ID INTEGER NOT NULL,
		PTC_NAME VARCHAR(256) NOT NULL,
		PTC_DESCRIPTION VARCHAR(2000),
		PTC_REPOID INTEGER NOT NULL,
		PTC_METADATA CLOB NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.PTCONFIG_USER (
		PTCU_USERID INTEGER NOT NULL,
		PTCU_CONFIGID INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.PTQUERY (
		PTQ_ID INTEGER NOT NULL,
		PTQ_NAME VARCHAR(256) NOT NULL,
		PTQ_DESCRIPTION VARCHAR(2000),
		PTQ_CONFIG_ID INTEGER NOT NULL,
		PTQ_METADATA CLOB NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.STALECACHE (
		STALE_KEY VARCHAR(100) NOT NULL,
		STALE_TIMESTAMP TIMESTAMP NOT NULL,
		SHORTDATA VARCHAR(100),
		LONGDATA CLOB,
		COLLISION INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.USER_PREFERENCES (
		USERID INTEGER NOT NULL,
		PREF_KEY INTEGER NOT NULL,
		STRINGDATA VARCHAR(3000),
		BINARYDATA BLOB,
		LAST_MODIFIED TIMESTAMP NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.USERGROUP (
		ID INTEGER NOT NULL,
		NAME VARCHAR(80) NOT NULL,
		DESCRIPTION VARCHAR(3000),
		TYPE INTEGER DEFAULT 0 NOT NULL,
		BINDINGID VARCHAR(200),
		RESOURCEGROUPID INTEGER NOT NULL,
		UG_COLLISION INTEGER DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.USERGROUP_ROLE (
		USERGROUPID INTEGER NOT NULL,
		ROLEID INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.USERGROUP_USER (
		USERID INTEGER NOT NULL,
		USERGROUPID INTEGER NOT NULL,
		UGU_CONTROL_COUNTER INTEGER DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.UGRP_RELATIONSHIP (
		ASSETID INTEGER NOT NULL,
		USERGROUPID INTEGER NOT NULL,
		KIND INTEGER NOT NULL,
		UGR_RESTRICT BIGINT DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.PTCONFIG_UGR (
		PTCUG_CONFIGID INTEGER NOT NULL,
		PTCUG_UGRPID INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.TODO_TARGET_UGRP (
		TODO_TG_REQ_USER INTEGER NOT NULL,
		TODO_TG_TYPE INTEGER NOT NULL,
		TODO_TG_LINK VARCHAR(1000) NOT NULL,
		TG_USERGROUP INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.FORUM (
		F_ID INTEGER NOT NULL,
		F_NAME VARCHAR(512) NOT NULL,
		F_OWNER INTEGER NOT NULL,
		F_UPDATED TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL,
		F_PT_CONFIGID INTEGER,
		F_DESCRIPTION VARCHAR(3000),
		F_METADATA CLOB,
		F_PRIVATE CHAR(1) DEFAULT NULL,
		F_COLLISION INTEGER DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.TOPIC (
		T_ID INTEGER NOT NULL,
		T_SUBJECT VARCHAR(1000) NOT NULL,
		T_FORUMID INTEGER NOT NULL,
		T_AUTHOR INTEGER NOT NULL,
		T_UPDATED TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL,
		T_BODY CLOB NOT NULL,
		T_METADATA CLOB,
		T_ATTACHMENT BIGINT,
		T_COLLISION INTEGER DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.ATTACHMENT (
		A_ID BIGINT NOT NULL,
		A_NAME VARCHAR(500) NOT NULL,
		A_DESCRIPTION VARCHAR(2000),
		A_FILE_URI VARCHAR(1000)
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.POST (
		P_ID BIGINT NOT NULL,
		P_BODY CLOB NOT NULL,
		P_REPLY_TO BIGINT,
		P_AUTHOR INTEGER NOT NULL,
		P_CREATED TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL,
		P_UPDATED TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL,
		P_TOPIC INTEGER NOT NULL,
		P_METADATA CLOB,
		P_ATTACHMENT BIGINT,
		P_COLLISION INTEGER DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.PTQUERY_FORUM (
		PTQF_QUERYID INTEGER NOT NULL,
		PTQF_FORUMID INTEGER NOT NULL,
		PTQF_DISPLAY_ORDER INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.ASSETTYPE_COMMUN (
		ATCM_ASSETTYPEID INTEGER NOT NULL,
		ATCM_COMMUNID INTEGER NOT NULL,
		ATCM_DESCRIPTION VARCHAR(512),
		ATCM_CONFIGURATION CLOB(1 G),
		ATCM_LOCAL CHAR(1),
		ATCM_COLLISION INTEGER DEFAULT 0 NOT NULL,
		ATCM_ATTR_CONTAINER VARCHAR(1000) DEFAULT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.CLASSIFSCH_COMM (
		CC_SCHEMA VARCHAR(1000) NOT NULL,
		CC_COMMUNITY INTEGER NOT NULL,
		CC_ACCESSKIND INTEGER NOT NULL,
		CC_COLLISION INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.EXTENSION_POINT (
		ID INTEGER NOT NULL,
		TYPE INTEGER NOT NULL,
		NAME VARCHAR(500) NOT NULL,
		CONFIGURATION CLOB,
		COLLISION INTEGER NOT NULL,
		EXT_ASSETID INTEGER DEFAULT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.FORUM_ASSET (
		FA_FORUM INTEGER NOT NULL,
		FA_ASSET INTEGER NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.LIBRARY (
		L_LIBASSETID INTEGER NOT NULL,
		L_ITEMTYPE INTEGER NOT NULL,
		L_DBID INTEGER DEFAULT NULL,
		L_DBVCID VARCHAR(1000) DEFAULT NULL,
		L_MODEL_OFFSET INTEGER NOT NULL,
		L_MODIFIED SMALLINT DEFAULT 0 NOT NULL,
		L_MODTIMESTAMP TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.FAVORITE (
		FV_ID INTEGER NOT NULL,
		FV_USERID INTEGER NOT NULL,
		FV_TITLE VARCHAR(500),
		FV_ORDER FLOAT(5) DEFAULT 0.0 NOT NULL,
		FV_TYPE INTEGER DEFAULT 0 NOT NULL,
		FV_IMG_MIMETYPE VARCHAR(50),
		FV_IMAGE BLOB,
		FV_DATA_MIMETYPE VARCHAR(50),
		FV_DATA CLOB,
		FV_COLLISION INTEGER DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.BUSY_ASSET (
		BA_ASSETID INTEGER NOT NULL,
		BA_TYPE CHAR(1) NOT NULL,
		BA_TIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL,
		BA_SERVER VARCHAR(500),
		BA_URI VARCHAR(1000)
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.TAG_MQT (
		MQTTAG_TAG VARCHAR(64) NOT NULL,
		MQTTAG_FIRSTCREATED TIMESTAMP NOT NULL,
		MQTTAG_LASTCREATED TIMESTAMP NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.LICENSE (
		LIC_USER INTEGER NOT NULL,
		LIC_LICENSE VARCHAR(100) NOT NULL,
		LIC_LAST_ALLOCATE TIMESTAMP DEFAULT '1990-01-01-00.00.00' NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.COUNTS (
		CNT_KEY VARCHAR(256) NOT NULL,
		CNT_VALUE BIGINT DEFAULT 0 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE TABLE RAMSCHEMA.LIFECYCLE (
		LC_ID VARCHAR(100) NOT NULL,
		LC_XML CLOB(1 G) NOT NULL,
		LC_ASSET INTEGER,
		LC_LASTMOD TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL,
		LC_NAME VARCHAR(1000) NOT NULL,
		LC_COLLISION INTEGER DEFAULT 0 NOT NULL,
		LC_COMMUNITYID INTEGER,
		LC_COMM_ORDER INTEGER DEFAULT -1 NOT NULL
	)
	 IN USERSPACE1 INDEX IN INDEXDMS LONG IN LONGDMS  ^

CREATE UNIQUE INDEX RAMSCHEMA.ASSET_EXTID
	ON RAMSCHEMA.ASSET
	(EXTERNALID		ASC,
	  VERSION		ASC,
	  PENDING_CTRL_FLAG		ASC)^

CREATE INDEX RAMSCHEMA.ASSET_COMMUN_TYPE
	ON RAMSCHEMA.ASSET
	(RESOURCEGROUP		ASC,
	  ASSETTYPEID		ASC)^

CREATE INDEX RAMSCHEMA.ASSET_LAST_DIRTY
	ON RAMSCHEMA.ASSET
	(LAST_DIRTY		ASC)^

CREATE UNIQUE INDEX RAMSCHEMA.ASSETTYPE_URI_IDX
	ON RAMSCHEMA.ASSETTYPE
	(URI		ASC)^

CREATE INDEX RAMSCHEMA.CLSCHEMA_LSTMOD
	ON RAMSCHEMA.CLASSIFSCHEMA
	(LAST_MODIFIED		DESC)^

CREATE INDEX RAMSCHEMA.METRICS_ASSET
	ON RAMSCHEMA.REPOSITORYMETRIC
	(METRICTYPE		ASC,
	  TIME_STAMP		DESC,
	  ASSETID		ASC,
	  USERID		ASC)^

CREATE INDEX RAMSCHEMA.METRIC_BY_ASSET
	ON RAMSCHEMA.REPOSITORYMETRIC
	(ASSETID		ASC,
	  METRICTYPE		ASC,
	  TIME_STAMP		DESC)^

CREATE INDEX RAMSCHEMA.ROLE_RESGROUPID
	ON RAMSCHEMA.REPOSITORYROLE
	(RESOURCEGROUPID		ASC)^

CREATE UNIQUE INDEX RAMSCHEMA.STATE_ID
	ON RAMSCHEMA.STATE
	(STATE_WF_ID		ASC)^

CREATE UNIQUE INDEX RAMSCHEMA.USER_USERID
	ON RAMSCHEMA.USERID
	(USERID		ASC)^

CREATE INDEX RAMSCHEMA.UREL_UID
	ON RAMSCHEMA.USERRELATIONSHIP
	(USERID		ASC,
	  KIND		ASC)^

CREATE INDEX RAMSCHEMA.REVIEW_ORDER
	ON RAMSCHEMA.REVIEW_PROCESS
	(GROUPID		ASC,
	  ORDER_IN_GROUP		ASC)^

CREATE INDEX RAMSCHEMA.SUBSCRB_TYP_ID_FRQ
	ON RAMSCHEMA.SUBSCRIPTION
	(DBID		ASC,
	  SUBSCRIPTION_TYPE		ASC,
	  FREQUENCY		ASC)^

CREATE INDEX RAMSCHEMA.SUBSCRB_UID
	ON RAMSCHEMA.SUBSCRIPTION
	(USERID		ASC)^

CREATE INDEX RAMSCHEMA.TAGS_USER
	ON RAMSCHEMA.TAG
	(USER_ID		ASC)^

CREATE UNIQUE INDEX RAMSCHEMA.TAGS_ASSET_TAG
	ON RAMSCHEMA.TAG
	(ASSET_ID		ASC,
	  TAG		ASC)^

CREATE INDEX RAMSCHEMA.TAGS
	ON RAMSCHEMA.TAG
	(TAG		ASC,
	  CREATED		ASC)^

CREATE INDEX RAMSCHEMA.ASTVERHSTRY_ASTID
	ON RAMSCHEMA.ASSETVERSIONHISTORY
	(ASSETID		ASC)^

CREATE INDEX RAMSCHEMA.TODO_TARGET_USERS
	ON RAMSCHEMA.TODO_TARGET_USER
	(TU_USERID		ASC)^

CREATE INDEX RAMSCHEMA.PTREPO_BY_GRP
	ON RAMSCHEMA.PTREPO
	(PTR_GROUPID		ASC)^

CREATE INDEX RAMSCHEMA.PTCNF_BY_REPO
	ON RAMSCHEMA.PTCONFIG
	(PTC_REPOID		ASC)^

CREATE INDEX RAMSCHEMA.PTQUERY_BY_CNF
	ON RAMSCHEMA.PTQUERY
	(PTQ_CONFIG_ID		ASC)^

CREATE INDEX RAMSCHEMA.UG_RESGROUPID
	ON RAMSCHEMA.USERGROUP
	(RESOURCEGROUPID		ASC)^

CREATE UNIQUE INDEX RAMSCHEMA.UGU_UG_US_NDX
	ON RAMSCHEMA.USERGROUP_USER
	(USERGROUPID		ASC,
	  USERID		ASC)^

CREATE INDEX RAMSCHEMA.UGRPREL_UGRP
	ON RAMSCHEMA.UGRP_RELATIONSHIP
	(USERGROUPID		ASC,
	  KIND		ASC)^

CREATE INDEX RAMSCHEMA.TODO_TARGET_UGRPS
	ON RAMSCHEMA.TODO_TARGET_UGRP
	(TG_USERGROUP		ASC)^

CREATE INDEX RAMSCHEMA.TOPIC_ATTACHMENT
	ON RAMSCHEMA.TOPIC
	(T_ATTACHMENT		ASC)^

CREATE INDEX RAMSCHEMA.TOPIC_FORUM
	ON RAMSCHEMA.TOPIC
	(T_FORUMID		ASC)^

CREATE INDEX RAMSCHEMA.POST_ATTACHMENT
	ON RAMSCHEMA.POST
	(P_ATTACHMENT		ASC)^

CREATE INDEX RAMSCHEMA.POST_TOPIC
	ON RAMSCHEMA.POST
	(P_TOPIC		ASC)^

CREATE INDEX RAMSCHEMA.POST_REPLY
	ON RAMSCHEMA.POST
	(P_REPLY_TO		ASC)^

CREATE INDEX RAMSCHEMA.PTQF_BY_FORUM
	ON RAMSCHEMA.PTQUERY_FORUM
	(PTQF_FORUMID		ASC)^

CREATE INDEX RAMSCHEMA.EXT_POINT_BY_TYPE
	ON RAMSCHEMA.EXTENSION_POINT
	(TYPE		ASC)^

CREATE UNIQUE INDEX RAMSCHEMA.FA_ASSET_FORUM_IDX
	ON RAMSCHEMA.FORUM_ASSET
	(FA_ASSET		ASC,
	  FA_FORUM		ASC)^

CREATE INDEX RAMSCHEMA.LIB_NDX
	ON RAMSCHEMA.LIBRARY
	(L_LIBASSETID		ASC)^

CREATE UNIQUE INDEX RAMSCHEMA.LIB_MODEL_IDX
	ON RAMSCHEMA.LIBRARY
	(L_ITEMTYPE		ASC,
	  L_DBID		ASC,
	  L_DBVCID		ASC)^

CREATE INDEX RAMSCHEMA.FV_USER_NDX
	ON RAMSCHEMA.FAVORITE
	(FV_USERID		ASC)^

CREATE INDEX RAMSCHEMA.TAG_LSTCRTD_NDX
	ON RAMSCHEMA.TAG_MQT
	(MQTTAG_LASTCREATED		DESC)^

CREATE INDEX RAMSCHEMA.TAG_LAST_UNIQ_NDX
	ON RAMSCHEMA.TAG_MQT
	(MQTTAG_FIRSTCREATED		DESC)^

CREATE INDEX RAMSCHEMA.LIC_LICENSE_NDX
	ON RAMSCHEMA.LICENSE
	(LIC_LICENSE		ASC,
	  LIC_LAST_ALLOCATE		DESC)^

CREATE INDEX RAMSCHEMA.COMMUNITY_NDX
	ON RAMSCHEMA.LIFECYCLE
	(LC_COMMUNITYID		ASC,
	  LC_COMM_ORDER		DESC)^

ALTER TABLE RAMSCHEMA.ASSET ADD CONSTRAINT SQL060302161907350 PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.ASSETTYPE ADD CONSTRAINT SQL060302161906150 PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.CLASSIFSCHEMA ADD CONSTRAINT SQL060302161906350 PRIMARY KEY
	(URI)^

ALTER TABLE RAMSCHEMA.GROUPUSERROLE ADD CONSTRAINT C0012647 PRIMARY KEY
	(USERID,
	 REPOSITORYROLEID)^

ALTER TABLE RAMSCHEMA.ASSETRELATIONTYPE ADD CONSTRAINT C9171363 PRIMARY KEY
	(NAME)^

ALTER TABLE RAMSCHEMA.ASSETRELATIONTYPE ADD CONSTRAINT RELTYPE_DN UNIQUE
	(DISPLAY_NAME)^

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC ADD CONSTRAINT C4752929 PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.REPOSITORYROLE ADD CONSTRAINT SQL060302161905930 PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.REPOSROLEENTITLEMENT ADD CONSTRAINT C4170611 PRIMARY KEY
	(REPOSROLEID,
	 ENTITLEID)^

ALTER TABLE RAMSCHEMA.RESOURCEGROUP ADD CONSTRAINT SQL060302161904960 PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.STATE ADD CONSTRAINT SQL060302161905260 PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.USERID ADD CONSTRAINT SQL060302161905480 PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.AUTOKEYGEN ADD CONSTRAINT C9766869 PRIMARY KEY
	(IDENTIFIER)^

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP ADD CONSTRAINT C3386788 PRIMARY KEY
	(ASSETID,
	 USERID,
	 KIND)^

ALTER TABLE RAMSCHEMA.CONFIGURATION ADD CONSTRAINT C9628234 PRIMARY KEY
	(CONFIG_KEY)^

ALTER TABLE RAMSCHEMA.REVIEW_PROCESS ADD CONSTRAINT C3977115 PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.SUBSCRIPTION ADD CONSTRAINT C9854034 PRIMARY KEY
	(SUB_ID)^

ALTER TABLE RAMSCHEMA.TAG ADD CONSTRAINT C3930063 PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.ASSETVERSIONHISTORY ADD CONSTRAINT C7220450 PRIMARY KEY
	(EXTERNALID,
	 VERSION,
	 AVH_SUBMISSION)^

ALTER TABLE RAMSCHEMA.TODO ADD CONSTRAINT C6295873 PRIMARY KEY
	(REQUESTING_USER,
	 TYPE,
	 ACTION_LINK)^

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER ADD CONSTRAINT C8444015 PRIMARY KEY
	(TODO_TU_REQ_USER,
	 TODO_TU_TYPE,
	 TODO_TU_LINK,
	 TU_USERID)^

ALTER TABLE RAMSCHEMA.PTREPO ADD CONSTRAINT C0201947 PRIMARY KEY
	(PTR_ID)^

ALTER TABLE RAMSCHEMA.PTCONFIG ADD CONSTRAINT C3648890 PRIMARY KEY
	(PTC_ID)^

ALTER TABLE RAMSCHEMA.PTCONFIG_USER ADD CONSTRAINT C6415283 PRIMARY KEY
	(PTCU_CONFIGID,
	 PTCU_USERID)^

ALTER TABLE RAMSCHEMA.PTQUERY ADD CONSTRAINT C0491965 PRIMARY KEY
	(PTQ_ID)^

ALTER TABLE RAMSCHEMA.STALECACHE ADD CONSTRAINT C3686525 PRIMARY KEY
	(STALE_KEY)^

ALTER TABLE RAMSCHEMA.USER_PREFERENCES ADD CONSTRAINT C12341234 PRIMARY KEY
	(USERID,
	 PREF_KEY)^

ALTER TABLE RAMSCHEMA.USERGROUP ADD CONSTRAINT USERGROUP_PK PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE ADD CONSTRAINT USERGROUPROLE_PK PRIMARY KEY
	(USERGROUPID,
	 ROLEID)^

ALTER TABLE RAMSCHEMA.USERGROUP_USER ADD CONSTRAINT USERGROUP_USER_PK PRIMARY KEY
	(USERID,
	 USERGROUPID)^

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP ADD CONSTRAINT UGR_PK PRIMARY KEY
	(ASSETID,
	 USERGROUPID,
	 KIND)^

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR ADD CONSTRAINT PTCONFIG_UGR_PK PRIMARY KEY
	(PTCUG_CONFIGID,
	 PTCUG_UGRPID)^

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP ADD CONSTRAINT TODO_TRGT_UGRP_PK PRIMARY KEY
	(TODO_TG_REQ_USER,
	 TODO_TG_TYPE,
	 TODO_TG_LINK,
	 TG_USERGROUP)^

ALTER TABLE RAMSCHEMA.FORUM ADD CONSTRAINT FORUM_PK PRIMARY KEY
	(F_ID)^

ALTER TABLE RAMSCHEMA.TOPIC ADD CONSTRAINT TOPIC_PK PRIMARY KEY
	(T_ID)^

ALTER TABLE RAMSCHEMA.ATTACHMENT ADD CONSTRAINT ATTACHMENT_PK PRIMARY KEY
	(A_ID)^

ALTER TABLE RAMSCHEMA.POST ADD CONSTRAINT POST_PK PRIMARY KEY
	(P_ID)^

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM ADD CONSTRAINT PT_QUERY_FORUM_PK PRIMARY KEY
	(PTQF_QUERYID,
	 PTQF_FORUMID)^

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN ADD CONSTRAINT ASSETTYP_COMMUN_PK PRIMARY KEY
	(ATCM_ASSETTYPEID,
	 ATCM_COMMUNID)^

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM ADD CONSTRAINT CLASSIFSCH_COMM_PK PRIMARY KEY
	(CC_SCHEMA,
	 CC_COMMUNITY)^

ALTER TABLE RAMSCHEMA.EXTENSION_POINT ADD CONSTRAINT EXTENSIONPOINT_PK PRIMARY KEY
	(ID)^

ALTER TABLE RAMSCHEMA.FORUM_ASSET ADD CONSTRAINT FORUM_ASSET_PK PRIMARY KEY
	(FA_FORUM,
	 FA_ASSET)^

ALTER TABLE RAMSCHEMA.LIBRARY ADD CONSTRAINT LIBRARY_CK CHECK (L_DBID IS NOT NULL OR L_DBVCID IS NOT NULL)^

ALTER TABLE RAMSCHEMA.FAVORITE ADD CONSTRAINT FAVORITES_PK PRIMARY KEY
	(FV_ID)^

ALTER TABLE RAMSCHEMA.BUSY_ASSET ADD CONSTRAINT BUSY_ASSET_PK PRIMARY KEY
	(BA_ASSETID)^

ALTER TABLE RAMSCHEMA.TAG_MQT ADD CONSTRAINT TAG_MQT_PK PRIMARY KEY
	(MQTTAG_TAG)^

ALTER TABLE RAMSCHEMA.LICENSE ADD CONSTRAINT LICENSE_PK PRIMARY KEY
	(LIC_USER,
	 LIC_LICENSE)^

ALTER TABLE RAMSCHEMA.COUNTS ADD CONSTRAINT COUNTS_PK PRIMARY KEY
	(CNT_KEY)^

ALTER TABLE RAMSCHEMA.LIFECYCLE ADD CONSTRAINT LIFECYCLE_PK PRIMARY KEY
	(LC_ID)^

ALTER TABLE RAMSCHEMA.ASSET ADD CONSTRAINT SQL060302161907351 FOREIGN KEY
	(ASSETTYPEID)
	REFERENCES RAMSCHEMA.ASSETTYPE
	(ID)
	ON DELETE SET NULL^

ALTER TABLE RAMSCHEMA.ASSET ADD CONSTRAINT SQL060302161907681 FOREIGN KEY
	(STATEID)
	REFERENCES RAMSCHEMA.STATE
	(ID)^

ALTER TABLE RAMSCHEMA.ASSET ADD CONSTRAINT C7034435 FOREIGN KEY
	(RESOURCEGROUP)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)^

ALTER TABLE RAMSCHEMA.ASSET ADD CONSTRAINT ASSET_LIFECYCLE_FK FOREIGN KEY
	(A_LCID)
	REFERENCES RAMSCHEMA.LIFECYCLE
	(LC_ID)^

ALTER TABLE RAMSCHEMA.GROUPUSERROLE ADD CONSTRAINT SQL060302161908452 FOREIGN KEY
	(REPOSITORYROLEID)
	REFERENCES RAMSCHEMA.REPOSITORYROLE
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.GROUPUSERROLE ADD CONSTRAINT SQL060302161908450 FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC ADD CONSTRAINT SQL060302161908680 FOREIGN KEY
	(ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)^

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC ADD CONSTRAINT C7264217 FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE SET NULL^

ALTER TABLE RAMSCHEMA.REPOSITORYROLE ADD CONSTRAINT C8818139 FOREIGN KEY
	(RESOURCEGROUPID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.REPOSROLEENTITLEMENT ADD CONSTRAINT SQL060302161908790 FOREIGN KEY
	(REPOSROLEID)
	REFERENCES RAMSCHEMA.REPOSITORYROLE
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.RESOURCEGROUP ADD CONSTRAINT COMMUNITY_ASSET_FK FOREIGN KEY
	(COMMUNITY_ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE SET NULL^

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP ADD CONSTRAINT C6359167 FOREIGN KEY
	(ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP ADD CONSTRAINT C5886019 FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.REVIEW_PROCESS ADD CONSTRAINT C9952475 FOREIGN KEY
	(GROUPID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.SUBSCRIPTION ADD CONSTRAINT C8704685 FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.TAG ADD CONSTRAINT C5102136 FOREIGN KEY
	(ASSET_ID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)^

ALTER TABLE RAMSCHEMA.TAG ADD CONSTRAINT C7483428 FOREIGN KEY
	(USER_ID)
	REFERENCES RAMSCHEMA.USERID
	(ID)^

ALTER TABLE RAMSCHEMA.ASSETVERSIONHISTORY ADD CONSTRAINT C1003852 FOREIGN KEY
	(ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.TODO ADD CONSTRAINT C8990529 FOREIGN KEY
	(REQUESTING_USER)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER ADD CONSTRAINT C5745917 FOREIGN KEY
	(TODO_TU_REQ_USER,
	 TODO_TU_TYPE,
	 TODO_TU_LINK)
	REFERENCES RAMSCHEMA.TODO
	(REQUESTING_USER,
	 TYPE,
	 ACTION_LINK)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER ADD CONSTRAINT C4245457 FOREIGN KEY
	(TU_USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.PTREPO ADD CONSTRAINT C0062924 FOREIGN KEY
	(PTR_GROUPID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.PTREPO ADD CONSTRAINT C3934317 FOREIGN KEY
	(PTR_OWNERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE SET NULL^

ALTER TABLE RAMSCHEMA.PTCONFIG ADD CONSTRAINT C7658548 FOREIGN KEY
	(PTC_REPOID)
	REFERENCES RAMSCHEMA.PTREPO
	(PTR_ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.PTCONFIG_USER ADD CONSTRAINT C5288775 FOREIGN KEY
	(PTCU_USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.PTCONFIG_USER ADD CONSTRAINT C8866283 FOREIGN KEY
	(PTCU_CONFIGID)
	REFERENCES RAMSCHEMA.PTCONFIG
	(PTC_ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.PTQUERY ADD CONSTRAINT C6065876 FOREIGN KEY
	(PTQ_CONFIG_ID)
	REFERENCES RAMSCHEMA.PTCONFIG
	(PTC_ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.USER_PREFERENCES ADD CONSTRAINT C4134514134 FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.USERGROUP ADD CONSTRAINT UGR_RESGROUP_FK FOREIGN KEY
	(RESOURCEGROUPID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE ADD CONSTRAINT UGR_UGR_FK FOREIGN KEY
	(USERGROUPID)
	REFERENCES RAMSCHEMA.USERGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE ADD CONSTRAINT UGR_ROLE_FK FOREIGN KEY
	(ROLEID)
	REFERENCES RAMSCHEMA.REPOSITORYROLE
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.USERGROUP_USER ADD CONSTRAINT UGU_USER_FK FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.USERGROUP_USER ADD CONSTRAINT UGU_UGR_FK FOREIGN KEY
	(USERGROUPID)
	REFERENCES RAMSCHEMA.USERGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP ADD CONSTRAINT UGR_ASSET_FK FOREIGN KEY
	(ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP ADD CONSTRAINT UGR_USERGROUP_FK FOREIGN KEY
	(USERGROUPID)
	REFERENCES RAMSCHEMA.USERGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR ADD CONSTRAINT PTCUG_PTCONFIG_FK FOREIGN KEY
	(PTCUG_CONFIGID)
	REFERENCES RAMSCHEMA.PTCONFIG
	(PTC_ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR ADD CONSTRAINT PTCUG_USERGROUP_FK FOREIGN KEY
	(PTCUG_UGRPID)
	REFERENCES RAMSCHEMA.USERGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP ADD CONSTRAINT TO_UGRP_TODO_FK FOREIGN KEY
	(TODO_TG_REQ_USER,
	 TODO_TG_TYPE,
	 TODO_TG_LINK)
	REFERENCES RAMSCHEMA.TODO
	(REQUESTING_USER,
	 TYPE,
	 ACTION_LINK)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP ADD CONSTRAINT TO_UGRP_UGRP_FK FOREIGN KEY
	(TG_USERGROUP)
	REFERENCES RAMSCHEMA.USERGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.FORUM ADD CONSTRAINT FORUM_PTCONFIG_FK FOREIGN KEY
	(F_PT_CONFIGID)
	REFERENCES RAMSCHEMA.PTCONFIG
	(PTC_ID)
	ON DELETE SET NULL^

ALTER TABLE RAMSCHEMA.FORUM ADD CONSTRAINT FORUM_OWNER_FK FOREIGN KEY
	(F_OWNER)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.TOPIC ADD CONSTRAINT TOPIC_FORUM_FK FOREIGN KEY
	(T_FORUMID)
	REFERENCES RAMSCHEMA.FORUM
	(F_ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.TOPIC ADD CONSTRAINT TOPIC_USERID_FK FOREIGN KEY
	(T_AUTHOR)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.TOPIC ADD CONSTRAINT TOPIC_ATTACH_FK FOREIGN KEY
	(T_ATTACHMENT)
	REFERENCES RAMSCHEMA.ATTACHMENT
	(A_ID)
	ON DELETE SET NULL^

ALTER TABLE RAMSCHEMA.POST ADD CONSTRAINT POST_TOPIC_FK FOREIGN KEY
	(P_TOPIC)
	REFERENCES RAMSCHEMA.TOPIC
	(T_ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.POST ADD CONSTRAINT POST_REPLY_FK FOREIGN KEY
	(P_REPLY_TO)
	REFERENCES RAMSCHEMA.POST
	(P_ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.POST ADD CONSTRAINT POST_ATTACHMENT_FK FOREIGN KEY
	(P_ATTACHMENT)
	REFERENCES RAMSCHEMA.ATTACHMENT
	(A_ID)
	ON DELETE SET NULL^

ALTER TABLE RAMSCHEMA.POST ADD CONSTRAINT POST_AUTHOR_FK FOREIGN KEY
	(P_AUTHOR)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM ADD CONSTRAINT PTQF_QUERY_FK FOREIGN KEY
	(PTQF_QUERYID)
	REFERENCES RAMSCHEMA.PTQUERY
	(PTQ_ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM ADD CONSTRAINT PTQF_FORUM_FK FOREIGN KEY
	(PTQF_FORUMID)
	REFERENCES RAMSCHEMA.FORUM
	(F_ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN ADD CONSTRAINT ATCM_ASSETTYPE_FK FOREIGN KEY
	(ATCM_ASSETTYPEID)
	REFERENCES RAMSCHEMA.ASSETTYPE
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN ADD CONSTRAINT ATCM_COMMUN_FK FOREIGN KEY
	(ATCM_COMMUNID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM ADD CONSTRAINT CC_SCHEMA_FK FOREIGN KEY
	(CC_SCHEMA)
	REFERENCES RAMSCHEMA.CLASSIFSCHEMA
	(URI)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM ADD CONSTRAINT CC_COMMUNITY_FK FOREIGN KEY
	(CC_COMMUNITY)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.EXTENSION_POINT ADD CONSTRAINT EXT_ASSET_FK FOREIGN KEY
	(EXT_ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE SET NULL^

ALTER TABLE RAMSCHEMA.FORUM_ASSET ADD CONSTRAINT FORUM_ASSET_FK FOREIGN KEY
	(FA_ASSET)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.FORUM_ASSET ADD CONSTRAINT FORUM_AST_FRM_FK FOREIGN KEY
	(FA_FORUM)
	REFERENCES RAMSCHEMA.FORUM
	(F_ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.LIBRARY ADD CONSTRAINT L_LIBASSET_FK FOREIGN KEY
	(L_LIBASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.FAVORITE ADD CONSTRAINT FV_USER_FK FOREIGN KEY
	(FV_USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.LICENSE ADD CONSTRAINT LICENSE_USERID_FK FOREIGN KEY
	(LIC_USER)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.LIFECYCLE ADD CONSTRAINT LIFECYCLE_ASSET_FK FOREIGN KEY
	(LC_ASSET)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE^

ALTER TABLE RAMSCHEMA.LIFECYCLE ADD CONSTRAINT LC_COMMUNITY_FK FOREIGN KEY
	(LC_COMMUNITYID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE^

CREATE TRIGGER RAMSCHEMA.ASSET_UPDATED_REC 
	NO CASCADE BEFORE UPDATE ON RAMSCHEMA.ASSET
	REFERENCING  NEW AS N
		OLD AS O
	FOR EACH ROW MODE DB2SQL
WHEN (O.LAST_DIRTY = N.LAST_DIRTY)
SET N.LAST_DIRTY = CURRENT_TIMESTAMP ^

CREATE TRIGGER RAMSCHEMA.ASSET_UPDATED_ART 
	NO CASCADE BEFORE UPDATE OF ARTIFACT_DETAILS ON RAMSCHEMA.ASSET
	REFERENCING  NEW AS N
	FOR EACH ROW MODE DB2SQL
SET N.LAST_ARTIFACTS_DIRTY = CURRENT_TIMESTAMP ^

CREATE TRIGGER RAMSCHEMA.AT_DELETE 
	AFTER DELETE ON RAMSCHEMA.ASSETTYPE
	REFERENCING  OLD AS O
	FOR EACH ROW MODE DB2SQL
WHEN (O.AT_ATTR_CONTAINER IS NOT NULL)
DELETE FROM RAMSCHEMA.CLASSIFSCHEMA WHERE URI = O.AT_ATTR_CONTAINER ^

CREATE TRIGGER RAMSCHEMA.CL_UPDATED 
	NO CASCADE BEFORE UPDATE ON RAMSCHEMA.CLASSIFSCHEMA
	REFERENCING  NEW AS N
	FOR EACH ROW MODE DB2SQL
SET N.LAST_MODIFIED = CURRENT_TIMESTAMP ^

CREATE TRIGGER RAMSCHEMA.FREQ_CHANGED 
	AFTER UPDATE OF SUBSCRIPTION_FREQUENCY ON RAMSCHEMA.USERID
	REFERENCING  NEW AS N
	FOR EACH ROW MODE DB2SQL
UPDATE RAMSCHEMA.SUBSCRIPTION SET FREQUENCY = N.SUBSCRIPTION_FREQUENCY WHERE RAMSCHEMA.SUBSCRIPTION.USERID = N.ID AND RAMSCHEMA.SUBSCRIPTION.FREQ_DEFAULTED IS NULL ^

CREATE TRIGGER RAMSCHEMA.FREQ_DFLT_CHANGED 
	NO CASCADE BEFORE UPDATE OF FREQ_DEFAULTED ON RAMSCHEMA.SUBSCRIPTION
	REFERENCING  NEW AS N
	FOR EACH ROW MODE DB2SQL
WHEN (N.FREQ_DEFAULTED IS NULL)
SET N.FREQUENCY =  (SELECT SUBSCRIPTION_FREQUENCY FROM RAMSCHEMA.USERID WHERE ID = N.USERID) ^

CREATE TRIGGER RAMSCHEMA.INSRT_SUBSCRIPTION 
	NO CASCADE BEFORE INSERT ON RAMSCHEMA.SUBSCRIPTION
	REFERENCING  NEW AS N
	FOR EACH ROW MODE DB2SQL
BEGIN ATOMIC 
  SET N.CREATED = CURRENT_TIMESTAMP;
  SET N.LAST_RUN = CURRENT_TIMESTAMP;
  IF N.FREQ_DEFAULTED IS NULL THEN 
    SET N.FREQUENCY =  (SELECT SUBSCRIPTION_FREQUENCY FROM RAMSCHEMA.USERID WHERE ID = N.USERID);
  END IF;
END ^

CREATE TRIGGER RAMSCHEMA.FORUM_UPDATE 
	NO CASCADE BEFORE UPDATE ON RAMSCHEMA.FORUM
	REFERENCING  NEW AS N
		OLD AS O
	FOR EACH ROW MODE DB2SQL
WHEN (O.F_UPDATED = N.F_UPDATED)
SET N.F_UPDATED = CURRENT_TIMESTAMP ^

CREATE TRIGGER RAMSCHEMA.TOPIC_DEL_ATTACH 
	NO CASCADE BEFORE DELETE ON RAMSCHEMA.TOPIC
	REFERENCING  OLD AS O
	FOR EACH ROW MODE DB2SQL
WHEN (O.T_ATTACHMENT IS NOT NULL)
SIGNAL SQLSTATE '75002' SET MESSAGE_TEXT = 'Cannot delete topic while there is an attachment.' ^

CREATE TRIGGER RAMSCHEMA.TOPIC_UPDATE_REC 
	NO CASCADE BEFORE UPDATE ON RAMSCHEMA.TOPIC
	REFERENCING  NEW AS N
		OLD AS O
	FOR EACH ROW MODE DB2SQL
WHEN (O.T_UPDATED = N.T_UPDATED)
BEGIN ATOMIC
  SET N.T_UPDATED = CURRENT_TIMESTAMP;
  IF N.T_COLLISION = O.T_COLLISION THEN
    SET N.T_COLLISION = N.T_COLLISION+1;
  END IF;  
END ^

CREATE TRIGGER RAMSCHEMA.TOPIC_INSERT_FORUM 
	AFTER INSERT ON RAMSCHEMA.TOPIC
	REFERENCING  NEW AS N
	FOR EACH ROW MODE DB2SQL
UPDATE RAMSCHEMA.FORUM SET F_UPDATED = CURRENT_TIMESTAMP WHERE N.T_FORUMID = F_ID ^

CREATE TRIGGER RAMSCHEMA.TOPIC_UPDATE_FORUM 
	AFTER UPDATE ON RAMSCHEMA.TOPIC
	REFERENCING  NEW AS N
	FOR EACH ROW MODE DB2SQL
UPDATE RAMSCHEMA.FORUM SET F_UPDATED = CURRENT_TIMESTAMP WHERE N.T_FORUMID = F_ID ^

CREATE TRIGGER RAMSCHEMA.TOPIC_DELETE_FORUM 
	AFTER DELETE ON RAMSCHEMA.TOPIC
	REFERENCING  OLD AS O
	FOR EACH ROW MODE DB2SQL
UPDATE RAMSCHEMA.FORUM SET F_UPDATED = CURRENT_TIMESTAMP WHERE O.T_FORUMID = F_ID ^

CREATE TRIGGER RAMSCHEMA.POST_DELETE_ATTACH 
	NO CASCADE BEFORE DELETE ON RAMSCHEMA.POST
	REFERENCING  OLD AS O
	FOR EACH ROW MODE DB2SQL
WHEN (O.P_ATTACHMENT IS NOT NULL)
SIGNAL SQLSTATE '75002' SET MESSAGE_TEXT = 'Cannot delete topic while there is an attachment.' ^

CREATE TRIGGER RAMSCHEMA.POST_UPDATE_REC 
	NO CASCADE BEFORE UPDATE ON RAMSCHEMA.POST
	REFERENCING  NEW AS N
		OLD AS O
	FOR EACH ROW MODE DB2SQL
WHEN (O.P_UPDATED = N.P_UPDATED)
BEGIN ATOMIC
  SET N.P_UPDATED = CURRENT_TIMESTAMP;
  IF N.P_COLLISION = O.P_COLLISION THEN
    SET N.P_COLLISION = N.P_COLLISION+1;
  END IF;  
END ^

CREATE TRIGGER RAMSCHEMA.POST_INSERT_TOPIC 
	AFTER INSERT ON RAMSCHEMA.POST
	REFERENCING  NEW AS N
	FOR EACH ROW MODE DB2SQL
UPDATE RAMSCHEMA.TOPIC SET T_UPDATED = CURRENT_TIMESTAMP WHERE N.P_TOPIC = T_ID ^

CREATE TRIGGER RAMSCHEMA.POST_UPDATE_TOPIC 
	AFTER UPDATE ON RAMSCHEMA.POST
	REFERENCING  NEW AS N
	FOR EACH ROW MODE DB2SQL
UPDATE RAMSCHEMA.TOPIC SET T_UPDATED = CURRENT_TIMESTAMP WHERE N.P_TOPIC =T_ID ^

CREATE TRIGGER RAMSCHEMA.POST_DELETE_TOPIC 
	AFTER DELETE ON RAMSCHEMA.POST
	REFERENCING  OLD AS O
	FOR EACH ROW MODE DB2SQL
UPDATE RAMSCHEMA.TOPIC SET T_UPDATED = CURRENT_TIMESTAMP WHERE O.P_TOPIC = T_ID ^

CREATE TRIGGER RAMSCHEMA.ATCM_DELETED 
	AFTER DELETE ON RAMSCHEMA.ASSETTYPE_COMMUN
	REFERENCING  OLD AS O
	FOR EACH ROW MODE DB2SQL
WHEN (O.ATCM_ATTR_CONTAINER IS NOT NULL)
DELETE FROM RAMSCHEMA.CLASSIFSCHEMA WHERE URI = O.ATCM_ATTR_CONTAINER ^

-- When DB2/Oracle selects an index for the primary key it first checks if any index already exists with exactly all of the same
-- columns as the primary key, regardless of order, it chooses that index, makes it unique and marks it as the primary index.
-- This makes some sense because for a primary key this will always be looking for all columns of the key to find the
-- row and so it doesn't matter which column is first in the index. 
--
-- This gives us a problem with FORUM_ASSET table because we need both (FORUM,ASSET) and (ASSET,FORUM) unique indexes because
-- we will be searching for all Forums of an asset or all Assets of a forum and using the same index for both would be very
-- inefficient. So we need to define both for DB2 because DB2 will choose one as the primary key index. This is because the
-- default SQL generating we are using creates the indexes before the primary keys are created. If the primary keys had
-- been created first then DB2 would of created the (FORUM,ASSET) index itself and then we would create just the (ASSET,FORUM)
-- index.
--
-- Now SQLServer always generate an index for the primary key. It doesn't try to be efficient by seeing if there is
-- an index already that works. So if for them we created both indexes then they would implicitly create a third index that was
-- a duplicate of the one we explicitly created.
--
-- To handle this the master SQL only generates the (ASSET,FORUM) index and lets SQLServer implicitly generate the
-- (FORUM,ASSET) index as the primary key. Then using this override file we will explicitly create the (FORUM,ASSET) index
-- here just for DB2 and let DB2 use the (ASSET,FORUM) index as the one used by the primary key lookup.
--
-- So what happens is that even though PK is (FORUM,ASSET), DB2/Oracle will choose either (FORUM,ASSET) or (ASSET,FORUM) for PK, but
-- we will explicitly have created both of them. But SQLServer will create (FORUM,ASSET) for PK, and we will
-- explicitly create (ASSET,FORUM).
--
-- Note: Additional tables with same problem:
-- USERGROUP_USER - PK UGU_US_UG_NDX:(USERID,USERGROUPID), extra index UGU_UG_US_NDX:(USERGROUPID,USERID).

CREATE UNIQUE INDEX RAMSCHEMA.FA_FORUM_ASSET_IDX ON RAMSCHEMA.FORUM_ASSET (FA_FORUM ASC, FA_ASSET ASC)^
CREATE UNIQUE INDEX RAMSCHEMA.UGU_US_UG_NDX ON RAMSCHEMA.USERGROUP_USER (USERID ASC, USERGROUPID ASC)^
 
-- Trigger counting number of licenses assigned to users for each kind of license.
CREATE TRIGGER RAMSCHEMA.LIC_COUNTS_ADD 
	AFTER INSERT ON RAMSCHEMA.LICENSE
	REFERENCING  NEW AS N
	FOR EACH ROW MODE DB2SQL
		UPDATE RAMSCHEMA.COUNTS SET CNT_VALUE=CNT_VALUE+1 WHERE CNT_KEY='lic.'||N.LIC_LICENSE^

CREATE TRIGGER RAMSCHEMA.LIC_COUNTS_REMOVE 
	AFTER DELETE ON RAMSCHEMA.LICENSE
	REFERENCING  OLD AS O
	FOR EACH ROW MODE DB2SQL
		UPDATE RAMSCHEMA.COUNTS SET CNT_VALUE=CNT_VALUE-1 WHERE CNT_KEY='lic.'||O.LIC_LICENSE^
	
